Field3DFileHDF5Base Class Referenceabstract
File I/O

`#include <Field3DFileHDF5.h>`

Inheritance diagram for Field3DFileHDF5Base:

## Classes

struct | LayerInfo

## Public Types

typedef std::map< std::string, std::string > | GroupMembershipMap

## Public Member Functions

void | clear ()
| Clear the data structures and close the file.
bool | close ()
| Closes the file. No need to call this unless you specifically want to close the file early. It will close once the FileHDF5 object goes out of scope.
FieldMetadata & | metadata ()
| accessor to the m_metadata class
const FieldMetadata & | metadata () const
| Read only access to the m_metadata class.
virtual void | metadataHasChanged (const std::string &)
| This function should implemented by concrete classes to get the callback when metadata changes.
Constructors & destructor
| Field3DFileHDF5Base ()
virtual | ~Field3DFileHDF5Base ()=0
| Pure virtual destructor to ensure we never instantiate this class.
Retreiving partition and layer names
void | getPartitionNames (std::vector< std::string > &names) const
| Gets the names of all the partitions in the file.
void | getScalarLayerNames (std::vector< std::string > &names, const std::string &partitionName) const
| Gets the names of all the scalar layers in a given partition.
void | getVectorLayerNames (std::vector< std::string > &names, const std::string &partitionName) const
| Gets the names of all the vector layers in a given partition.
FileHDF5::Partition::Ptr | getPartition (const std::string &partitionName) const
| Returns a pointer to the given partition.
Convenience methods for partitionName
std::string | intPartitionName (const std::string &partitionName, const std::string &layerName, FieldRes::Ptr field)
| Returns a unique partition name given the requested name. This ensures that partitions with matching mappings get the same name but each subsequent differing mapping gets a new, separate name.
std::string | removeUniqueId (const std::string &partitionName) const
| Strips any unique identifiers from the partition name and returns the original name.
void | addGroupMembership (const GroupMembershipMap &groupMembers)
| Add to the group membership.
Debug
void | printHierarchy () const

## Protected Types

typedef std::map< std::string, int > | PartitionCountMap
typedef std::vector< FileHDF5::Partition::Ptr > | PartitionList

## Protected Member Functions

Convenience methods
void | closeInternal ()
| Closes the file if open.
FileHDF5::Partition::Ptr | partition (const std::string &partitionName)
| Returns a pointer to the given partition.
FileHDF5::Partition::Ptr | partition (const std::string &partitionName) const
| Returns a pointer to the given partition.
void | getIntPartitionNames (std::vector< std::string > &names) const
| Gets the names of all the -internal- partitions in the file.
void | getIntScalarLayerNames (std::vector< std::string > &names, const std::string &intPartitionName) const
| Gets the names of all the scalar layers in a given partition, but assumes that partition name is the -internal- partition name.
void | getIntVectorLayerNames (std::vector< std::string > &names, const std::string &intPartitionName) const
| Gets the names of all the vector layers in a given partition, but assumes that partition name is the -internal- partition name.
int | numIntPartitions (const std::string &partitionName) const
| Returns the number of internal partitions for a given partition name.
std::string | makeIntPartitionName (const std::string &partitionsName, int i) const
| Makes an internal partition name given the external partition name. Effectively just tacks on .X to the name, where X is the number.

## Protected Attributes

hid_t | m_file
| The hdf5 id of the current file. Will be -1 if no file is open.
GroupMembershipMap | m_groupMembership
| Keeps track of group membership for each layer of partition name. The key is the "group" and the value is a space separated list of "partitionName.0:Layer1 partitionName.1:Layer0 ...".
std::vector< LayerInfo > | m_layerInfo
| This stores layer info.
FieldMetadata | m_metadata
| metadata
PartitionCountMap | m_partitionCount
| Contains a counter for each partition name. This is used to keep multiple fields with the same name unique in the file.
std::vector< std::string > | m_partitionNames
| This stores partition names.
PartitionList | m_partitions
| Vector of partitions.

## Private Member Functions

| Field3DFileHDF5Base (const Field3DFileHDF5Base &)
void | operator= (const Field3DFileHDF5Base &)

## Friends

class | Field3DInputFile
class | Field3DOutputFile

## Detailed Description

Provides some common functionality for Field3DInputFileHDF5 and Field3DOutputFileHDF5. It hold the partition->layer data structures, but knows nothing about how to actually get them to/from disk.

Definition at line 236 of file Field3DFileHDF5.h.

## Member Typedef Documentation

## GroupMembershipMap

typedef std::map<std::string, std::string> Field3DFileHDF5Base::GroupMembershipMap

Definition at line 257 of file Field3DFileHDF5.h.

## PartitionList

typedef std::vector<FileHDF5::Partition::Ptr> Field3DFileHDF5Base::PartitionList

protected

Definition at line 346 of file Field3DFileHDF5.h.

## PartitionCountMap

typedef std::map<std::string, int> Field3DFileHDF5Base::PartitionCountMap

protected

Definition at line 347 of file Field3DFileHDF5.h.

## Constructor & Destructor Documentation

## Field3DFileHDF5Base() [1/2]

Field3DFileHDF5Base::Field3DFileHDF5Base | ( |  | ) |

Definition at line 290 of file Field3DFileHDF5.cpp.

: m_file(-1), m_metadata(this)
{
GlobalLock lock(g_hdf5Mutex);
// Suppressing HDF error messages
// Explanation about the function for the error stack is here:
// http://www.hdfgroup.org/HDF5/doc/RM/RM_H5E.html#Error-SetAuto2
if (getenv("DEBUG_HDF")) {
cerr << "Field3DFileHDF5 -- HDF5 messages are on" << endl;
H5Eset_auto(H5E_DEFAULT, localPrintError, NULL);
} else {
H5Eset_auto(H5E_DEFAULT, NULL, NULL);
}
}
g_hdf5Mutex
FIELD3D_NAMESPACE_OPEN FIELD3D_API boost::recursive_mutex g_hdf5Mutex
Definition Hdf5Util.cpp:67
GlobalLock
boost::recursive_mutex::scoped_lock GlobalLock
Definition Hdf5Util.h:78
Field3DFileHDF5Base::m_file
hid_t m_file
The hdf5 id of the current file. Will be -1 if no file is open.
Definition Field3DFileHDF5.h:390
Field3DFileHDF5Base::m_metadata
FieldMetadata m_metadata
metadata
Definition Field3DFileHDF5.h:406

References g_hdf5Mutex, m_file, and m_metadata.

Referenced by Field3DFileHDF5Base(), and operator=().

## ~Field3DFileHDF5Base()

Field3DFileHDF5Base::~Field3DFileHDF5Base | ( |  | ) |

pure virtual

Pure virtual destructor to ensure we never instantiate this class.

Definition at line 308 of file Field3DFileHDF5.cpp.

{
close();
}
Field3DFileHDF5Base::close
bool close()
Closes the file. No need to call this unless you specifically want to close the file early....
Definition Field3DFileHDF5.cpp:496

References close().

## Field3DFileHDF5Base() [2/2]

Field3DFileHDF5Base::Field3DFileHDF5Base | ( | const Field3DFileHDF5Base & |  | ) |

private

References Field3DFileHDF5Base().

## Member Function Documentation

## clear()

void Field3DFileHDF5Base::clear | ( |  | ) |

Clear the data structures and close the file.

Definition at line 487 of file Field3DFileHDF5.cpp.

{
closeInternal();
m_partitions.clear();
m_groupMembership.clear();
}
Field3DFileHDF5Base::m_partitions
PartitionList m_partitions
Vector of partitions.
Definition Field3DFileHDF5.h:392
Field3DFileHDF5Base::m_groupMembership
GroupMembershipMap m_groupMembership
Keeps track of group membership for each layer of partition name. The key is the "group" and the valu...
Definition Field3DFileHDF5.h:403
Field3DFileHDF5Base::closeInternal
void closeInternal()
Closes the file if open.
Definition Field3DFileHDF5.cpp:505

References closeInternal(), m_groupMembership, and m_partitions.

Referenced by Field3DInputFileHDF5::open(), and Field3DInputFileHDF5::~Field3DInputFileHDF5().

## close()

bool Field3DFileHDF5Base::close | ( |  | ) |

Closes the file. No need to call this unless you specifically want to close the file early. It will close once the FileHDF5 object goes out of scope.

Definition at line 496 of file Field3DFileHDF5.cpp.

{
closeInternal();
return true;
}

References closeInternal().

Referenced by Field3DInputFileHDF5::open(), and ~Field3DFileHDF5Base().

## getPartitionNames()

void Field3DFileHDF5Base::getPartitionNames | ( | std::vector< std::string > & | names | ) | const

Gets the names of all the partitions in the file.

Definition at line 386 of file Field3DFileHDF5.cpp.

{
names.clear();
vector<string> tempNames;
for (PartitionList::const_iterator i = m_partitions.begin();
i != m_partitions.end(); ++i) {
tempNames.push_back(removeUniqueId((**i).name));
}
names = makeUnique(tempNames);
}
Field3DFileHDF5Base::removeUniqueId
std::string removeUniqueId(const std::string &partitionName) const
Strips any unique identifiers from the partition name and returns the original name.
Definition Field3DFileHDF5.cpp:373

References m_partitions, and removeUniqueId().

Referenced by Field3DInputFileHDF5::readProxyScalarLayers(), and Field3DInputFileHDF5::readProxyVectorLayers().

## getScalarLayerNames()

void Field3DFileHDF5Base::getScalarLayerNames | ( | std::vector< std::string > & | names,
|  | const std::string & | partitionName ) const

Gets the names of all the scalar layers in a given partition.

Definition at line 403 of file Field3DFileHDF5.cpp.

{
names.clear();
for (int i = 0; i < numIntPartitions(partitionName); i++) {
string internalName = makeIntPartitionName(partitionName, i);
Partition::Ptr part = partition(internalName);
if (part)
part->getScalarLayerNames(names);
}
names = makeUnique(names);
}
Field3DFileHDF5Base::makeIntPartitionName
std::string makeIntPartitionName(const std::string &partitionsName, int i) const
Makes an internal partition name given the external partition name. Effectively just tacks on ....
Definition Field3DFileHDF5.cpp:542
Field3DFileHDF5Base::numIntPartitions
int numIntPartitions(const std::string &partitionName) const
Returns the number of internal partitions for a given partition name.
Definition Field3DFileHDF5.cpp:521
Field3DFileHDF5Base::partition
FileHDF5::Partition::Ptr partition(const std::string &partitionName)
Returns a pointer to the given partition.
FileHDF5::Partition::Ptr
boost::intrusive_ptr< Partition > Ptr
Definition Field3DFileHDF5.h:152

References makeIntPartitionName(), numIntPartitions(), and partition().

Referenced by Field3DInputFileHDF5::readProxyScalarLayers().

## getVectorLayerNames()

void Field3DFileHDF5Base::getVectorLayerNames | ( | std::vector< std::string > & | names,
|  | const std::string & | partitionName ) const

Gets the names of all the vector layers in a given partition.

Definition at line 421 of file Field3DFileHDF5.cpp.

{
names.clear();
for (int i = 0; i < numIntPartitions(partitionName); i++) {
string internalName = makeIntPartitionName(partitionName, i);
Partition::Ptr part = partition(internalName);
if (part)
part->getVectorLayerNames(names);
}
names = makeUnique(names);
}

References makeIntPartitionName(), numIntPartitions(), and partition().

Referenced by Field3DInputFileHDF5::readProxyVectorLayers().

## getPartition()

FileHDF5::Partition::Ptr Field3DFileHDF5Base::getPartition | ( | const std::string & | partitionName | ) | const

inline

Returns a pointer to the given partition.

Returns
  NULL if no partition was found of that name

Definition at line 294 of file Field3DFileHDF5.h.

{ return partition(partitionName); }

References partition().

## intPartitionName()

std::string Field3DFileHDF5Base::intPartitionName | ( | const std::string & | partitionName,
|  | const std::string & | layerName,
|  | FieldRes::Ptr | field )

Returns a unique partition name given the requested name. This ensures that partitions with matching mappings get the same name but each subsequent differing mapping gets a new, separate name.

Definition at line 316 of file Field3DFileHDF5.cpp.

{
// Loop over existing partitions and see if there's a matching mapping
for (PartitionList::const_iterator i = m_partitions.begin();
i != m_partitions.end(); ++i) {
if (removeUniqueId((**i).name) == partitionName) {
if ((**i).mapping->isIdentical(field->mapping())) {
return (**i).name;
}
}
}
// If there was no previously matching name, then make a new one
int nextIdx = -1;
if (m_partitionCount.find(partitionName) != m_partitionCount.end()) {
nextIdx = ++m_partitionCount[partitionName];
} else {
nextIdx = 0;
m_partitionCount[partitionName] = 0;
}
return makeIntPartitionName(partitionName, nextIdx);
}
Field3DFileHDF5Base::m_partitionCount
PartitionCountMap m_partitionCount
Contains a counter for each partition name. This is used to keep multiple fields with the same name u...
Definition Field3DFileHDF5.h:398

References m_partitionCount, m_partitions, makeIntPartitionName(), and removeUniqueId().

Referenced by getIntScalarLayerNames(), getIntVectorLayerNames(), partition(), Field3DInputFileHDF5::readLayer(), Field3DInputFileHDF5::readScalarLayer(), Field3DInputFileHDF5::readVectorLayer(), and Field3DOutputFileHDF5::writeLayer().

## removeUniqueId()

std::string Field3DFileHDF5Base::removeUniqueId | ( | const std::string & | partitionName | ) | const

Strips any unique identifiers from the partition name and returns the original name.

Definition at line 373 of file Field3DFileHDF5.cpp.

{
size_t pos = partitionName.rfind(".");
if (pos == partitionName.npos) {
return partitionName;
} else {
return partitionName.substr(0, pos);
}
}

Referenced by getPartitionNames(), Field3DOutputFileHDF5::incrementPartitionName(), intPartitionName(), Field3DInputFileHDF5::readGroupMembership(), Field3DInputFileHDF5::readLayer(), Field3DInputFileHDF5::readProxyLayer(), Field3DInputFileHDF5::readScalarLayers(), and Field3DInputFileHDF5::readVectorLayers().

## addGroupMembership()

void Field3DFileHDF5Base::addGroupMembership | ( | const GroupMembershipMap & | groupMembers | ) |

Add to the group membership.

Definition at line 551 of file Field3DFileHDF5.cpp.

{
GroupMembershipMap::const_iterator i= groupMembers.begin();
GroupMembershipMap::const_iterator end= groupMembers.end();
for (; i != end; ++i) {
GroupMembershipMap::iterator foundGroupIter =
m_groupMembership.find(i->first);
if (foundGroupIter != m_groupMembership.end()){
std::string value = m_groupMembership[i->first] + i->second;
m_groupMembership[i->first] = value;
} else {
m_groupMembership[i->first] = i->second;
}
}
}

References m_groupMembership.

## metadata() [1/2]

FieldMetadata & Field3DFileHDF5Base::metadata | ( |  | ) |

inline

accessor to the m_metadata class

Definition at line 321 of file Field3DFileHDF5.h.

{ return m_metadata; }

References m_metadata.

Referenced by Field3DInputFileHDF5::readMetadata(), and Field3DOutputFileHDF5::writeMetadata().

## metadata() [2/2]

const FieldMetadata & Field3DFileHDF5Base::metadata | ( |  | ) | const

inline

Read only access to the m_metadata class.

Definition at line 325 of file Field3DFileHDF5.h.

{ return m_metadata; }

References m_metadata.

## metadataHasChanged()

virtual void Field3DFileHDF5Base::metadataHasChanged | ( | const std::string & |  | ) |

inline virtual

This function should implemented by concrete classes to
get the callback when metadata changes.

Reimplemented from MetadataCallback.

Definition at line 330 of file Field3DFileHDF5.h.

{ /* Empty */ }

## printHierarchy()

void Field3DFileHDF5Base::printHierarchy | ( |  | ) | const

Definition at line 1564 of file Field3DFileHDF5.cpp.

{
// For each partition
for (PartitionList::const_iterator i = m_partitions.begin();
i != m_partitions.end(); ++i) {
cout << "Name: " << (**i).name << endl;
if ((**i).mapping)
cout << " Mapping: " << (**i).mapping->className() << endl;
else
cout << " Mapping: NULL" << endl;
cout << " Scalar layers: " << endl;
vector<string> sNames;
(**i).getScalarLayerNames(sNames);
for_each(sNames.begin(), sNames.end(), print<string>(4));
cout << " Vector layers: " << endl;
vector<string> vNames;
(**i).getVectorLayerNames(vNames);
for_each(vNames.begin(), vNames.end(), print<string>(4));
}
}

References m_partitions.

## closeInternal()

void Field3DFileHDF5Base::closeInternal | ( |  | ) |

protected

Closes the file if open.

Definition at line 505 of file Field3DFileHDF5.cpp.

{
GlobalLock lock(g_hdf5Mutex);
if (m_file != -1) {
if (H5Fclose(m_file) < 0) {
Msg::print(Msg::SevWarning, "Failed to close hdf5 file handle");
return;
}
m_file = -1;
}
}
Msg::SevWarning
@ SevWarning
Definition Log.h:68
Msg::print
FIELD3D_API void print(Severity severity, const std::string &message)
Sends the string to the assigned output, prefixing the message with the severity.
Definition Log.cpp:70

References g_hdf5Mutex, m_file, Msg::print(), and Msg::SevWarning.

Referenced by clear(), close(), and Field3DOutputFileHDF5::create().

## partition() [1/2]

FileHDF5::Partition::Ptr Field3DFileHDF5Base::partition | ( | const std::string & | partitionName | ) |

protected

Returns a pointer to the given partition.

Returns
  NULL if no partition was found of that name

Referenced by Field3DOutputFileHDF5::createNewPartition(), getIntScalarLayerNames(), getIntVectorLayerNames(), getPartition(), getScalarLayerNames(), getVectorLayerNames(), Field3DInputFileHDF5::readLayer(), Field3DInputFileHDF5::readPartitionAndLayerInfo(), Field3DInputFileHDF5::readProxyLayer(), and Field3DOutputFileHDF5::writeLayer().

## partition() [2/2]

FileHDF5::Partition::Ptr Field3DFileHDF5Base::partition | ( | const std::string & | partitionName | ) | const

protected

Returns a pointer to the given partition.

Returns
  NULL if no partition was found of that name

References getIntPartitionNames(), getIntScalarLayerNames(), getIntVectorLayerNames(), intPartitionName(), makeIntPartitionName(), and numIntPartitions().

## getIntPartitionNames()

void Field3DFileHDF5Base::getIntPartitionNames | ( | std::vector< std::string > & | names | ) | const

protected

Gets the names of all the -internal- partitions in the file.

Definition at line 439 of file Field3DFileHDF5.cpp.

{
names.clear();
for (PartitionList::const_iterator i = m_partitions.begin();
i != m_partitions.end(); ++i) {
names.push_back((**i).name);
}
}

References m_partitions.

Referenced by partition(), Field3DInputFileHDF5::readProxyLayer(), Field3DInputFileHDF5::readScalarLayers(), Field3DInputFileHDF5::readScalarLayers(), Field3DInputFileHDF5::readVectorLayers(), and Field3DInputFileHDF5::readVectorLayers().

## getIntScalarLayerNames()

void Field3DFileHDF5Base::getIntScalarLayerNames | ( | std::vector< std::string > & | names,
|  | const std::string & | intPartitionName ) const

protected

Gets the names of all the scalar layers in a given partition, but assumes that partition name is the -internal- partition name.

Definition at line 452 of file Field3DFileHDF5.cpp.

{
names.clear();
Partition::Ptr part = partition(intPartitionName);
if (!part) {
Msg::print("getIntScalarLayerNames no partition: " + intPartitionName);
return;
}
part->getScalarLayerNames(names);
}
Field3DFileHDF5Base::intPartitionName
std::string intPartitionName(const std::string &partitionName, const std::string &layerName, FieldRes::Ptr field)
Returns a unique partition name given the requested name. This ensures that partitions with matching ...
Definition Field3DFileHDF5.cpp:316

References intPartitionName(), partition(), and Msg::print().

Referenced by partition(), Field3DInputFileHDF5::readProxyLayer(), Field3DInputFileHDF5::readScalarLayers(), and Field3DInputFileHDF5::readScalarLayers().

## getIntVectorLayerNames()

void Field3DFileHDF5Base::getIntVectorLayerNames | ( | std::vector< std::string > & | names,
|  | const std::string & | intPartitionName ) const

protected

Gets the names of all the vector layers in a given partition, but assumes that partition name is the -internal- partition name.

Definition at line 470 of file Field3DFileHDF5.cpp.

{
names.clear();
Partition::Ptr part = partition(intPartitionName);
if (!part) {
Msg::print("getIntVectorLayerNames no partition: " + intPartitionName);
return;
}
part->getVectorLayerNames(names);
}

References intPartitionName(), partition(), and Msg::print().

Referenced by partition(), Field3DInputFileHDF5::readProxyLayer(), Field3DInputFileHDF5::readVectorLayers(), and Field3DInputFileHDF5::readVectorLayers().

## numIntPartitions()

int Field3DFileHDF5Base::numIntPartitions | ( | const std::string & | partitionName | ) | const

protected

Returns the number of internal partitions for a given partition name.

Definition at line 521 of file Field3DFileHDF5.cpp.

{
int count = 0;
for (PartitionList::const_iterator i = m_partitions.begin();
i != m_partitions.end(); ++i) {
string name = (**i).name;
size_t pos = name.rfind(".");
if (pos != name.npos) {
if (name.substr(0, pos) == partitionName) {
count++;
}
}
}
return count;
}

References m_partitions.

Referenced by getScalarLayerNames(), getVectorLayerNames(), and partition().

## makeIntPartitionName()

string Field3DFileHDF5Base::makeIntPartitionName | ( | const std::string & | partitionsName,
|  | int | i ) const

protected

Makes an internal partition name given the external partition name. Effectively just tacks on .X to the name, where X is the number.

Definition at line 542 of file Field3DFileHDF5.cpp.

{
return partitionName + "." + boost::lexical_cast<std::string>(i);
}

Referenced by getScalarLayerNames(), getVectorLayerNames(), Field3DOutputFileHDF5::incrementPartitionName(), intPartitionName(), and partition().

## operator=()

void Field3DFileHDF5Base::operator= | ( | const Field3DFileHDF5Base & |  | ) |

private

References Field3DFileHDF5Base().

## Friends And Related Symbol Documentation

## Field3DInputFile

friend class Field3DInputFile

friend

Definition at line 240 of file Field3DFileHDF5.h.

References Field3DInputFile.

Referenced by Field3DInputFile.

## Field3DOutputFile

friend class Field3DOutputFile

friend

Definition at line 241 of file Field3DFileHDF5.h.

References Field3DOutputFile.

Referenced by Field3DOutputFile.

## Member Data Documentation

## m_layerInfo

std::vector<LayerInfo> Field3DFileHDF5Base::m_layerInfo

protected

This stores layer info.

Definition at line 387 of file Field3DFileHDF5.h.

Referenced by Field3DInputFileHDF5::parseLayer(), and Field3DInputFileHDF5::readPartitionAndLayerInfo().

## m_file

hid_t Field3DFileHDF5Base::m_file

protected

The hdf5 id of the current file. Will be -1 if no file is open.

Definition at line 390 of file Field3DFileHDF5.h.

Referenced by closeInternal(), Field3DOutputFileHDF5::create(), Field3DOutputFileHDF5::createNewPartition(), Field3DFileHDF5Base(), Field3DInputFileHDF5::open(), Field3DInputFileHDF5::readGroupMembership(), Field3DInputFileHDF5::readLayer(), Field3DInputFileHDF5::readPartitionAndLayerInfo(), Field3DInputFileHDF5::readProxyLayer(), Field3DOutputFileHDF5::writeGlobalMetadata(), Field3DOutputFileHDF5::writeGroupMembership(), and Field3DOutputFileHDF5::writeLayer().

## m_partitions

PartitionList Field3DFileHDF5Base::m_partitions

protected

Vector of partitions.

Definition at line 392 of file Field3DFileHDF5.h.

Referenced by clear(), Field3DOutputFileHDF5::createNewPartition(), getIntPartitionNames(), getPartitionNames(), intPartitionName(), numIntPartitions(), printHierarchy(), and Field3DInputFileHDF5::readPartitionAndLayerInfo().

## m_partitionNames

std::vector<std::string> Field3DFileHDF5Base::m_partitionNames

protected

This stores partition names.

Definition at line 394 of file Field3DFileHDF5.h.

Referenced by Field3DInputFileHDF5::parsePartition(), and Field3DInputFileHDF5::readPartitionAndLayerInfo().

## m_partitionCount

PartitionCountMap Field3DFileHDF5Base::m_partitionCount

protected

Contains a counter for each partition name. This is used to keep multiple fields with the same name unique in the file.

Definition at line 398 of file Field3DFileHDF5.h.

Referenced by Field3DOutputFileHDF5::incrementPartitionName(), and intPartitionName().

## m_groupMembership

GroupMembershipMap Field3DFileHDF5Base::m_groupMembership

protected

Keeps track of group membership for each layer of partition name. The key is the "group" and the value is a space separated list of "partitionName.0:Layer1 partitionName.1:Layer0 ...".

Definition at line 403 of file Field3DFileHDF5.h.

Referenced by addGroupMembership(), clear(), Field3DInputFileHDF5::readGroupMembership(), and Field3DOutputFileHDF5::writeGroupMembership().

## m_metadata

FieldMetadata Field3DFileHDF5Base::m_metadata

protected

metadata

Definition at line 406 of file Field3DFileHDF5.h.

Referenced by Field3DFileHDF5Base(), metadata(), and metadata().

The documentation for this class was generated from the following files:

- export/Field3DFileHDF5.h
- src/Field3DFileHDF5.cpp